﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using MxWSim.Utilities;

namespace MxWSim
{
    internal class Program
    {
        /// Internal
        public static string version = "1.1.1";
        /// Loop and Console Logic
        public static string state = "init";
        public static string last_state = "";
        public static bool loop = true;
        /// Job Logic
        List<int> jq = new List<int>();
        static void Main(string[] args)
        {
            while (loop)
            {
                switch (state)
                {
                    case "init":
                        Message.CMW($"[{state}] Initializing the ecosystem.", true, 1);
                        state = "status";
                        last_state = "init";
                        break;
                    case "status":
                        Message.CMW($"[{state}] Changing MxWSim status to \"READY\".", true, 1);
                        DB.SetMxWSimStatus("READY", Settings.GetBID());
                        state = "idle";
                        last_state = "status";
                        break;
                    case "idle":
                        if (last_state != "idle") { Message.CMW($"[{state}] Waiting for jobs in queue...", true, 2); }
                        if (DB.CountAwaitingInQueueByStatus("WAITING") >= 1)
                        {
                            if (DB.EnumerateQueueByStatus("WAITING").Count >= 1)
                            {
                                foreach (var q in DB.EnumerateQueueByStatus("WAITING"))
                                {
                                    Message.CMW($"[{state}] Changing MxWSim status to \"WORKING\".", true, 1);
                                    DB.SetMxWSimStatus("WORKING", Settings.GetBID());
                                    Message.CMW($"[{state}] Processing Queued Sim ID#{q} for User {DB.GetUserNameByUID(DB.GetUserUIDByQID(q))} (ID#{DB.GetUserUIDByQID(q)}).", true, 1);
                                    string data = DB.GetQueueDataByQID(q);
                                    File.WriteAllText($"tmp/{DB.GetUserUIDByQID(q)}.simc", data);
                                    Sim.RunSim(q);
                                    Sim.SendSim(DB.GetUserUIDByQID(q));
                                    Gear.AddSimGear(DB.GetUserUIDByQID(q));
                                    DB.SetQueueStatus("DONE", q);
                                }
                            }                           
                        }
                        Message.CMW($"[{state}] Waiting for 10 seconds...", true, 2);
                        Thread.Sleep(10000);
                        last_state = "idle";
                        break;
                }
            }
        }
    }
}
