﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace MxWSim.Utilities
{
    internal class Settings
    {        
        public class SETTINGS
        {
            public string dbname { get; set; }
            public string dbhost { get; set; }
            public string dbport { get; set; }
            public string dbuser { get; set; }
            public string dbpass { get; set; }
            public string simpath { get; set; }
            public int bid { get; set; }
        }

        ///<summary>
        ///Load the Database Host from the Settings Json.
        ///</summary>
        public static string GetDBHost() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json")).dbhost;
        ///<summary>
        ///Load the Database Port from the Settings Json.
        ///</summary>
        public static string GetDBPort() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json")).dbport;
        ///<summary>
        ///Load the Database Name from the Settings Json.
        ///</summary>
        public static string GetDBName() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json")).dbname;
        ///<summary>
        ///Load the Database User from the Settings Json.
        ///</summary>
        public static string GetDBUser() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json")).dbuser;
        ///<summary>
        ///Load the Database Password from the Settings Json.
        ///</summary>
        public static string GetDBPass() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json")).dbpass;
        ///<summary>
        ///Load the Simc Path from the Settings Json.
        ///</summary>
        public static string GetSimPath() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json")).simpath;
        ///<summary>
        ///Load the MxG Backend ID from the Json.
        ///</summary>
        public static int GetBID() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("settings.json")).bid;
    }
}
