﻿using Google.Protobuf.WellKnownTypes;
using MySqlConnector;
using Newtonsoft.Json;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;
using System.IO;
using System.Configuration;

namespace MxWSim.Utilities
{
    internal class Sim
    {
        // Root myDeserializedClass = JsonConvert.DeserializeObject<Root>(myJsonResponse);

        public class ActualAmount
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class Attribute
        {
            public double strength { get; set; }
            public double agility { get; set; }
            public double stamina { get; set; }
            public double intellect { get; set; }
        }

        public class AvgActualAmount
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class Back
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int crit_rating { get; set; }
            public int mastery_rating { get; set; }
            public int stragiint { get; set; }
        }

        public class BuffsConstant
        {
            public string name { get; set; }
            public string spell_name { get; set; }
            public string spell_school { get; set; }
            public int spell { get; set; }
            public double start_count { get; set; }
            public double duration { get; set; }
            public double uptime { get; set; }
            public double default_value { get; set; }
            public double? overflow_stacks { get; set; }
            public double? overflow_total { get; set; }
            public Cooldown cooldown { get; set; }
        }

        public class Chest
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int strint { get; set; }
            public int crit_rating { get; set; }
            public int haste_rating { get; set; }
        }

        public class CombatEndResource
        {
            public Health health { get; set; }
            public HolyPower holy_power { get; set; }
        }

        public class CompoundDmg
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class Cooldown
        {
            public string name { get; set; }
            public double duration { get; set; }
        }

        public class Count
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class Custom
        {
        }

        public class Dmg
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class Dps
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
            public double median { get; set; }
            public double variance { get; set; }
            public double std_dev { get; set; }
            public double mean_variance { get; set; }
            public double mean_std_dev { get; set; }
        }

        public class Dpse
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class ExecutedForegroundActions
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class Feet
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int strint { get; set; }
            public int crit_rating { get; set; }
            public int versatility_rating { get; set; }
        }

        public class FightActualAmount
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class FightLength
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class FightTotalAmount
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class Finger1
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int haste_rating { get; set; }
            public int versatility_rating { get; set; }
        }

        public class Finger2
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int crit_rating { get; set; }
            public int haste_rating { get; set; }
        }

        public class Gain
        {
            public string name { get; set; }
            public HolyPower holy_power { get; set; }
            public Health health { get; set; }
        }

        public class Hands
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int strint { get; set; }
            public int haste_rating { get; set; }
            public int mastery_rating { get; set; }
        }

        public class Head
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int crit_rating { get; set; }
            public int mastery_rating { get; set; }
            public int strint { get; set; }
        }

        public class Health
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
            public double mean_std_dev { get; set; }
            public List<double> data { get; set; }
            public double actual { get; set; }
            public double overflow { get; set; }
        }

        public class HealthPct
        {
            public double mean { get; set; }
            public double mean_std_dev { get; set; }
            public double min { get; set; }
            public double max { get; set; }
            public List<double> data { get; set; }
        }

        public class HolyPower
        {
            public double sum { get; set; }
            public double count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
            public double mean_std_dev { get; set; }
            public List<double> data { get; set; }
            public double actual { get; set; }
            public double overflow { get; set; }
        }

        public class Item
        {
            public int id { get; set; }
            public int ilevel { get; set; }
        }

        public class Legs
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int haste_rating { get; set; }
            public int mastery_rating { get; set; }
            public int strint { get; set; }
        }

        public class MainHand
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int strength { get; set; }
            public int stamina { get; set; }
            public int haste_rating { get; set; }
            public int mastery_rating { get; set; }
        }

        public class OffHand
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int strength { get; set; }
            public int stamina { get; set; }
            public int haste_rating { get; set; }
            public int mastery_rating { get; set; }
        }

        public class Neck
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int haste_rating { get; set; }
            public int mastery_rating { get; set; }
        }

        public class NumDirectResults
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class NumExecutes
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class NumRefreshes
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class NumTickResults
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class NumTicks
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }
        public class OverkillPct
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class Overrides
        {
            public int arcane_intellect { get; set; }
            public int battle_shout { get; set; }
            public int power_word_fortitude { get; set; }
            public int chaos_brand { get; set; }
            public int mystic_touch { get; set; }
            public int mortal_wounds { get; set; }
            public int bleeding { get; set; }
            public int bloodlust { get; set; }
        }

        public class Player
        {
            public string name { get; set; }
            public string race { get; set; }
            public int level { get; set; }
            public string role { get; set; }
            public string specialization { get; set; }
            public string talents { get; set; }
            public Professions professions { get; set; }
            public Gear gear { get; set; }
        }

        public class Gear
        {
            public Head head { get; set; }
            public Neck neck { get; set; }
            public Shoulders shoulders { get; set; }
            public Chest chest { get; set; }
            public Waist waist { get; set; }
            public Legs legs { get; set; }
            public Feet feet { get; set; }
            public Wrists wrists { get; set; }
            public Hands hands { get; set; }
            public Finger1 finger1 { get; set; }
            public Finger2 finger2 { get; set; }
            public Trinket1 trinket1 { get; set; }
            public Trinket2 trinket2 { get; set; }
            public Back back { get; set; }
            public MainHand main_hand { get; set; }
            public OffHand off_hand { get; set; }
        }

        public class PortionAps
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class PortionApse
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class Proc
        {
            public string name { get; set; }
            public double interval { get; set; }
            public double count { get; set; }
        }

        public class Professions
        {
            public int mining { get; set; }
            public int blacksmithing { get; set; }
        }

        public class RaidAps
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class RaidDps
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
            public double median { get; set; }
            public double variance { get; set; }
            public double std_dev { get; set; }
            public double mean_variance { get; set; }
            public double mean_std_dev { get; set; }
        }

        public class ResourceGain
        {
            public string name { get; set; }
            public HolyPower holy_power { get; set; }
        }

        public class ResourceLost
        {
            public Health health { get; set; }
            public HolyPower holy_power { get; set; }
        }

        public class ResourceOverflowed
        {
            public Health health { get; set; }
            public HolyPower holy_power { get; set; }
        }

        public class Resources
        {
            public double health { get; set; }
            public double holy_power { get; set; }
        }

        public class ResourcesMax
        {
            public double health { get; set; }
            public double holy_power { get; set; }
        }

        public class ResourceTimelines
        {
            public Health health { get; set; }
            public HealthPct health_pct { get; set; }
            public HolyPower holy_power { get; set; }
        }

        public class Rng
        {
            public string name { get; set; }
        }

        public class Root
        {
            public string version { get; set; }
            public string report_version { get; set; }
            public int ptr_enabled { get; set; }
            public int beta_enabled { get; set; }
            public string build_date { get; set; }
            public string build_time { get; set; }
            public int timestamp { get; set; }
            public string git_revision { get; set; }
            public string git_branch { get; set; }
            public Sims sim { get; set; }
        }

        public class Shoulders
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int strint { get; set; }
            public int mastery_rating { get; set; }
            public int versatility_rating { get; set; }
        }

        public class Sims
        {
            public List<Player> players { get; set; }
            public Statistics statistics { get; set; }
        }

        public class SimAura
        {
            public string name { get; set; }
            public string spell_name { get; set; }
            public string spell_school { get; set; }
            public int spell { get; set; }
            public double start_count { get; set; }
            public double duration { get; set; }
            public double uptime { get; set; }
            public double default_value { get; set; }
            public Cooldown cooldown { get; set; }
        }

        public class SimulationLength
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
            public double median { get; set; }
            public double variance { get; set; }
            public double std_dev { get; set; }
            public double mean_variance { get; set; }
            public double mean_std_dev { get; set; }
        }

        public class StackUptime
        {
            public double mean { get; set; }
            public double mean_std_dev { get; set; }
            public double min { get; set; }
            public double max { get; set; }
            public List<double> data { get; set; }
        }

        public class Statistics
        {
            public double elapsed_cpu_seconds { get; set; }
            public double elapsed_time_seconds { get; set; }
            public double init_time_seconds { get; set; }
            public double merge_time_seconds { get; set; }
            public double analyze_time_seconds { get; set; }
            public SimulationLength simulation_length { get; set; }
            public int total_events_processed { get; set; }
            public RaidDps raid_dps { get; set; }
            public RaidAps raid_aps { get; set; }
            public TotalDmg total_dmg { get; set; }
            public TotalAbsorb total_absorb { get; set; }
        }

        public class StatsPets
        {
        }

        public class TargetMetric
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
            public double median { get; set; }
            public double variance { get; set; }
            public double std_dev { get; set; }
            public double mean_variance { get; set; }
            public double mean_std_dev { get; set; }
        }

        public class ThewarwithinBETA
        {
            public int build_level { get; set; }
            public string wow_version { get; set; }
            public string hotfix_date { get; set; }
            public int hotfix_build { get; set; }
            public string hotfix_hash { get; set; }
        }

        public class TimelineDmg
        {
            public double mean { get; set; }
            public double mean_std_dev { get; set; }
            public double min { get; set; }
            public double max { get; set; }
            public List<double> data { get; set; }
        }

        public class TotalAbsorb
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class TotalAmount
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class TotalDmg
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class TotalExecuteTime
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class TotalIntervals
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class TotalTickTime
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
        }

        public class Trinket1
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stragiint { get; set; }
        }

        public class Trinket2
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int haste_rating { get; set; }
            public int stragiint { get; set; }
        }

        public class Waist
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int strint { get; set; }
            public int crit_rating { get; set; }
            public int haste_rating { get; set; }
        }

        public class WaitingTime
        {
            public double sum { get; set; }
            public int count { get; set; }
            public double mean { get; set; }
            public double min { get; set; }
            public double max { get; set; }
        }

        public class Wrists
        {
            public string name { get; set; }
            public string encoded_item { get; set; }
            public int ilevel { get; set; }
            public int stamina { get; set; }
            public int strint { get; set; }
            public int haste_rating { get; set; }
            public int mastery_rating { get; set; }
        }


        public static void RunSim(int qid)
        {
            int uid = DB.GetUserUIDByQID(qid);

            Process p = new Process();
            p.StartInfo.FileName = "/bin/bash";
            p.StartInfo.Arguments = $"simc.sh tmp/{uid}.simc json=tmp/\"{uid}.json\"";
            p.Start();
            p.WaitForExit();
        }

        public static void SendSim(int uid)
        {           
            using (var con = DB.MxWDB())
            {
                Root r = JsonConvert.DeserializeObject<Root>(File.ReadAllText($"tmp/{uid}.json"));
                string[] specs = r.sim.players[0].specialization.Split(' ');
                int spelen = specs.Length;
                string simclass = specs[spelen-1];
                Message.CMW(Utilities.Gear.CalculateGearIlvl(uid).ToString(), true, 4);
                string cmdText = $"INSERT INTO mxw_sim(uid, name, class, level, ilvl, length, dps, version) VALUES ('{uid}','{r.sim.players[0].name}','{simclass}','{r.sim.players[0].level}','{Utilities.Gear.CalculateGearIlvl(uid)}','{r.sim.statistics.simulation_length.mean}','{r.sim.statistics.raid_dps.mean}','{Program.version}|{r.version}')";
                MySqlCommand cmd = new MySqlCommand(cmdText, con);
                con.Open();
                cmd.ExecuteNonQuery();
                con.Close();
            }
        }
    }
}
